#!/usr/bin/perl
# 
# crashmail2jamnntpd.pl version 1.0 by Johan Billing
# This program has been released into the public domain, use it any way you want.
#

use Text::ParseWords;
use Getopt::Long;

sub printarea {
   unless ( $keyword eq 'area' and ( lc($area) eq 'default' or lc(substr($area,0,8)) eq 'default_' ) ) {
      unless ( ( $keyword eq 'netmail' and $opts{nonetmail} ) or 
               ( $keyword eq 'localarea' and $opts{nolocal} ) or 
               ( $keyword eq 'area' and lc($area) eq 'bad' and $opts{nobad} ) ) {
         
         if ( lc($msgbase) eq 'jam') {
            if ( !$group) {
               $group = $opts{defaultgroup};
            }
      
            if ( !$group) {
               $group = '""';
            }
      
            if ( $keyword eq 'netmail' ) {
               $area = '!'.$area;
            }
            elsif ( $keyword eq 'localarea' ) {
               $area = '$'.$area;
            }
            
            printf GROUPSFILE ("%-30s %-3s %-15s %s\n",$area,$group,$aka,$path);
         }
         elsif ( $msgbase ) {
            print "Warning: Area $area is not a JAM area, skipping...\n";
         }
      }
   }
}

$getopt_res = GetOptions(\%opts, 'defaultgroup|g=s', 
                                 'nonetmail|nn', 
                                 'nolocal|nl',
                                 'nobad|nb',
                                 'help|h'  );
            
if ( !$getopt_res or $opts{help} or $#ARGV != 1) {
   print "\n";
   print "Usage: [perl] crashmail2jamnntpd.pl <crashmail.prefs> <jamnntpd.groups>\n";
   print "\n";
   print "Valid options are:\n";
   print "\n";
   print " --g=X  or --defaultgroup=X  Group for areas with unspecified group\n";
   print " --nn   or --nonetmail       Do not include netmail areas in jamnntpd.groups\n";
   print " --nl   or --nolocal         Do not include local areas in jamnntpd.groups\n";
   print " --nb   or --nobad           Do not include BAD area in jamnntpd.groups\n";
   print " --h    or --help            Show this information\n";
   print "\n";
   
   exit (0);
}                   

$prefsfile = $ARGV[0];
$groupsfile = $ARGV[1];

# Read config file

open (PREFSFILE, $prefsfile) or die "Cannot open $prefsfile";
open (GROUPSFILE, ">$groupsfile") or die "Cannot write to $groupsfile";

print GROUPSFILE "# Created from $prefsfile by crashmail2jamnntpd.pl\n";
print GROUPSFILE "#\n";
print GROUPSFILE "# Some tweaking may be required.\n";
print GROUPSFILE "\n";

while (<PREFSFILE>) {
   s/\s+$//; # strip trailing whitespace

   if ( ! /^;/ ) {
      @words = quotewords('\s+', 0, $_);

      if ( lc($words[0]) eq 'area' or lc($words[0]) eq 'netmail' or lc($words[0]) eq 'localarea' ) {
         if ( $area ) {
            printarea;
         }
         
         $keyword = lc($words[0]);
         $area    = $words[1];
         $aka     = $words[2];
         $msgbase = $words[3];
         $path    = $words[4];
         $group   = '';
      }
      elsif ( lc($words[0]) eq 'group' ) {
         $group = $words[1];
      }
   }
}

if ( $area ) {
   printarea;
}

close (FIDOCONFIG);
close (GROUPSFILE);

